"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNotConsumedPurchase = exports.getPurchase = exports.init = void 0;
var appHttp = __importStar(require("../components/app-http"));
var appStorage = __importStar(require("../components/app-storage"));
var utils_1 = require("../utils/utils");
var init = function (initialData) {
    appStorage.saveInitialData(initialData);
};
exports.init = init;
var isNotConsumedPurchase = function (purchase) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
                var response, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!purchase.packageName.trim()) {
                                return [2 /*return*/, reject("Package name is invalid.")];
                            }
                            if (!purchase.productId.trim()) {
                                return [2 /*return*/, reject("Product is not found.")];
                            }
                            if (!purchase.purchaseToken.trim()) {
                                return [2 /*return*/, reject("The requested purchase is not found!")];
                            }
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, getPurchase(purchase)];
                        case 2:
                            response = _a.sent();
                            resolve(response.consumptionState == 1);
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            reject(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); })];
    });
}); };
exports.isNotConsumedPurchase = isNotConsumedPurchase;
var getPurchase = function (purchase) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) {
                tryToGetPurchase(purchase, {
                    onSuccess: function (response) {
                        resolve(response);
                    },
                    onUnauthorized: function () {
                        updateAccessToken()
                            .then(function () {
                            tryToGetPurchase(purchase, {
                                onSuccess: function (response) {
                                    resolve(response);
                                },
                                onFailure: function (error) {
                                    reject(error);
                                },
                            });
                        })
                            .catch(function (error) {
                            reject(error);
                        });
                    },
                    onFailure: function (error) {
                        reject(error);
                    },
                });
            })];
    });
}); };
exports.getPurchase = getPurchase;
var tryToGetPurchase = function (purchaseValue, appResponse) {
    var url = "https://pardakht.cafebazaar.ir/devapi/v2/api/validate/".concat(purchaseValue.packageName, "/inapp/").concat(purchaseValue.productId, "/purchases/").concat(purchaseValue.purchaseToken, "?access_token=").concat(appStorage.getAccessToken());
    (0, utils_1.appLog)("Try to validate purchase '".concat(purchaseValue.productId, "'..."));
    appHttp.post({ url: url }, {
        onSuccess: function (response) {
            appResponse.onSuccess(response);
        },
        onUnauthorized: function () {
            var _a;
            (_a = appResponse.onUnauthorized) === null || _a === void 0 ? void 0 : _a.call(appResponse);
        },
        onFailure: function (error) {
            appResponse.onFailure(error);
        },
    });
};
var updateAccessToken = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
                var initialData, formData, url;
                return __generator(this, function (_a) {
                    initialData = appStorage.getInitialData();
                    formData = new URLSearchParams();
                    formData.append("grant_type", "refresh_token");
                    formData.append("client_id", initialData.clientId);
                    formData.append("client_secret", initialData.clientSecret);
                    formData.append("refresh_token", initialData.refreshToken);
                    url = "https://pardakht.cafebazaar.ir/devapi/v2/auth/token/";
                    appHttp.post({ url: url, data: formData }, {
                        onSuccess: function (response) {
                            appStorage.updateAccessToken(response.access_token);
                            resolve();
                        },
                        onFailure: function (error) {
                            reject(error);
                        },
                    });
                    return [2 /*return*/];
                });
            }); })];
    });
}); };
